/*
********************************************************************************
*	[Contents]
*		API֐`t@C
*	[File Name]
*		api.h
*	[Author]
*		IDEC
*	[Note]
*		[System Information]
*			Product Name:	Y1437 HG1H`^eB[`Oy_g API
*			CPU:			V850ES/KG2
*			Compiler:		CA850
*			OS:				-
*		[History]
*			2006/Jun/05	쐬
*			2006/Aug/08	ROMݏ֐̈ύX
*			2006/Aug/24	ʃtbV֐ǉ
*			2006/Sep/18	uXCb`̔zύX
*			<V1.01>
*			2007/Sep/13	J[\NA̒萔`HG_CLRHG_ClrHomeɕύX
*						iLCD֐(hg_ctrl_LCD)̈̎dlύX̂߁j
*						iHG_CLR̒萔`͊iƂ̌݊̂߂ɋLqj
********************************************************************************
*/

/******************************************************************************/
/*
/*	\̒`
/*
/******************************************************************************/

/* uXCb` */
typedef struct {
		char key_table[5][8];
} HG_KEY_INFO;

/* n[hEFA */
typedef union {
		unsigned int		WORD[2];			/* Word Access */
		struct {								/* Bit  Access */
			unsigned int	COM			:2;		/* ʐMʁFRS232C(0), RS485(1), RS422(2) */
			unsigned int	BACKLIGHT	:2;		/* obNCgFȂ(0), (1) */
			unsigned int	MEMORY		:2;		/* FȂ(0), (1) */
			unsigned int	POWER		:2;		/* dFDC24V(0), DC5V(1) */
			unsigned int	REVISION	:4;		/* ^[Qbgo[W */
			unsigned int	reserve		:4;		/* \ */
			unsigned int	API_VER		:16;	/* APIo[W */
			unsigned int  	reserve2	:8;		/* \ */
			unsigned int	reserve3	:24;	/* \ */
		}        BIT;
} HG_TARGET_INFO;

/* \tgEFA */
typedef struct {
		int	reserve[6];				/* \ */
		char version[2];			/* \tgEFAo[W */
		char reserve2[2];			/* \ */
		int	reserve3;				/* \ */
		char name[32];				/* Rg */
} HG_SYSTEM_INFO;

/* API֐ */
typedef struct {
	char (*hg_ctrl_LED)( char led_no, char on_off ) ;
	char (*hg_ctrl_BZ)( char on_off ) ;
	char (*hg_get_SSW)( void ) ;
	char (*hg_ctrl_LCD)( char command ) ;
	char (*hg_dsp_adr)( char x, char y ) ;
	char (*hg_dsp_strings)( char *data ) ;
	void (*hg_ctrl_Contrast)( unsigned char data ) ;
	void (*hg_ctrl_Backlight)( unsigned char data ) ;
	char (*hg_write_externalROM)( char *dst, char *src , int data_byte ) ;
	char (*hg_erase_externalROM)( int erase_adr, int erase_byte ) ;
	void (*hg_get_keyinfo_all)( HG_KEY_INFO *key_info) ;
	char (*hg_get_keyinfo_indiv)( char x, char y ) ;
	char (*hg_comopen)(int baud, char mode) ;
	char (*hg_ctrl_422)(char enable) ;
	char (*hg_ctrl_232CS )(void) ;
	char (*hg_ctrl_232RS )(char on_off) ;
	void (*hg_get_targetinfo)( HG_TARGET_INFO *target_info ) ;
	void (*hg_get_systeminfo)(HG_SYSTEM_INFO *sys_info ) ;
	char (*hg_init_internalROM)( char block, char num ) ;
	char (*hg_write_internalROM)( char *data ) ;
	char (*hg_read_internalROM)( char *data ) ;
	char (*hg_refresh_LCD)( void ) ;
} HG_API_INFO ;


/******************************************************************************/
/*
/*	萔`
/*
/******************************************************************************/

#define HG_NO_ER	0			/* I */
#define HG_ER		-1			/* ُI */
#define HG_BUSY		1			/* 	*/

#define HG_OFF		0x00		/* OFF */
#define HG_ON		0x01		/* ON */
#define HG_CLR		0x01		/* J[\NA *//* Ver.1.00p */
#define HG_ClrHome	0x81		/* J[\NA *//* Ver.1.01ȏp */
#define HG_DspON	0x0c		/* J[\\Ȃŕ\ON */
#define HG_CurON	0x0e		/* J[\\ŕ\ON */
#define HG_Blink	0x0d		/* J[\ʒu̕_ */
#define HG_DspOFF	0x08		/* \OFF */
#define HG_CurSiftR	0x94		/* J[\EɃVtg */
#define HG_CurSiftL	0x90		/* J[\ɃVtg */

#define HG_API_ADDRESS_TOP 0x490	/* API֐e[ü */

#define hg_ctrl_LED 			(*(((HG_API_INFO *)HG_API_ADDRESS_TOP)->hg_ctrl_LED))
#define hg_ctrl_BZ 				(*(((HG_API_INFO *)HG_API_ADDRESS_TOP)->hg_ctrl_BZ))
#define hg_get_SSW 				(*(((HG_API_INFO *)HG_API_ADDRESS_TOP)->hg_get_SSW))
#define hg_ctrl_LCD 			(*(((HG_API_INFO *)HG_API_ADDRESS_TOP)->hg_ctrl_LCD))
#define hg_dsp_adr 				(*(((HG_API_INFO *)HG_API_ADDRESS_TOP)->hg_dsp_adr))
#define hg_dsp_strings 			(*(((HG_API_INFO *)HG_API_ADDRESS_TOP)->hg_dsp_strings))
#define hg_ctrl_Contrast 		(*(((HG_API_INFO *)HG_API_ADDRESS_TOP)->hg_ctrl_Contrast))
#define hg_ctrl_Backlight 		(*(((HG_API_INFO *)HG_API_ADDRESS_TOP)->hg_ctrl_Backlight))
#define hg_write_externalROM	(*(((HG_API_INFO *)HG_API_ADDRESS_TOP)->hg_write_externalROM))
#define hg_erase_externalROM	(*(((HG_API_INFO *)HG_API_ADDRESS_TOP)->hg_erase_externalROM))
#define hg_get_keyinfo_all 		(*(((HG_API_INFO *)HG_API_ADDRESS_TOP)->hg_get_keyinfo_all))
#define hg_get_keyinfo_indiv 	(*(((HG_API_INFO *)HG_API_ADDRESS_TOP)->hg_get_keyinfo_indiv))
#define hg_comopen 				(*(((HG_API_INFO *)HG_API_ADDRESS_TOP)->hg_comopen))
#define hg_ctrl_422 			(*(((HG_API_INFO *)HG_API_ADDRESS_TOP)->hg_ctrl_422))
#define hg_ctrl_232CS 			(*(((HG_API_INFO *)HG_API_ADDRESS_TOP)->hg_ctrl_232CS))
#define hg_ctrl_232RS 			(*(((HG_API_INFO *)HG_API_ADDRESS_TOP)->hg_ctrl_232RS))
#define hg_get_targetinfo 		(*(((HG_API_INFO *)HG_API_ADDRESS_TOP)->hg_get_targetinfo))
#define hg_get_systeminfo 		(*(((HG_API_INFO *)HG_API_ADDRESS_TOP)->hg_get_systeminfo))
#define hg_init_internalROM 	(*(((HG_API_INFO *)HG_API_ADDRESS_TOP)->hg_init_internalROM))
#define hg_write_internalROM 	(*(((HG_API_INFO *)HG_API_ADDRESS_TOP)->hg_write_internalROM))
#define hg_read_internalROM 	(*(((HG_API_INFO *)HG_API_ADDRESS_TOP)->hg_read_internalROM))
#define hg_refresh_LCD 			(*(((HG_API_INFO *)HG_API_ADDRESS_TOP)->hg_refresh_LCD))

